/**************************
* BB                       *
* just a simple button-bar *
*                          *
* (c) by T.Mueller         *
* licensed under GPL       *
* version: 0.5             *
 **************************/

#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <signal.h>
#ifdef SOLARIS
	#include <sys/loadavg.h>
#endif
#define true 1
#define false 0
#define MAXSTRING 256
#define BUTTON "empty"
#define PROGTITEL "ButtonBar"
#define TEXTHEIGHT 10

int buttonalign='V';
int tipdelay=3;
int posx=-1;
int posy=-1;
char HOSTNAME[MAXSTRING+1];
char USERNAME[MAXSTRING+1];
char ICOPRE[MAXSTRING+1];
int useicons=1;
int usetext=0;
int usedecs=1;
int load=0;
char LOAD[MAXSTRING+1];
char SLOAD[MAXSTRING+1];
char USERHOST[MAXSTRING+1];
int fqdn=0;
int nohup=1;

/************************************************************************
 * Bad Problem :                                                        *
 * This tool allocs mem, but doesn`t free it yet.                       *
 * I hope *every* UniX free`s the memory after the program ist stooped. *
 * If you know how to fix this: tell me !                               *
 ************************************************************************/
GtkTooltips *tooltips;
GtkWidget *window;
GtkWidget *loadlabel;
GtkWidget *status;
char *calledPath;
guint stid;

static void signal_handler (int sig) {
	switch (sig) {
		case SIGHUP:
			printf ("%s: Caught SIGHUP !\n", PROGTITEL);
		break;
		case SIGQUIT:
			printf ("%s: Caught SIGQUIT !\n", PROGTITEL);
		break;
		case SIGTERM:
			printf ("%s: Caught SIGTERM !\n", PROGTITEL);
		break;
		case SIGABRT:
			printf ("%s: Caught SIGABRT !\n", PROGTITEL);
		break;
		case SIGINT:
			printf ("%s: Caught SIGINT !\n", PROGTITEL);
		break;
		case SIGUSR1:
			printf ("Why do you tickle me ?\nSirTobi doesn't like that !\n");
		break;
		default:
			printf ("%s: Caught Signal %i !\n", PROGTITEL, sig);
		break;
	}
}

void execSub(GtkWidget *widget, gpointer *menu) {
	gtk_menu_popup (GTK_MENU(menu), NULL, NULL, NULL, NULL, 0, 0);
}

void execCom(GtkWidget *widget, gpointer *command) {
  char *z1;
	int shellcom;

	if(strstr((char *)command,"[QUIT]") == (char *)command) {
		gtk_main_quit();
		return;
	}

	if(strstr((char *)command,"[SHELL]") == (char *)command)
		shellcom=1;
	else
		shellcom=0;
		

	if(shellcom == 0)
	  z1=malloc(strlen((char *)command)+2);
	else
		z1=malloc(strlen((char *)gtk_entry_get_text(GTK_ENTRY(widget)))+2);
  if(z1 != (char *)NULL) {
		if(shellcom == 0)	
    	strcpy(z1,(char *)command);
		else
			strcpy(z1,(char *)gtk_entry_get_text(GTK_ENTRY(widget)));
    strcat(z1,"&");
    system(z1);
    free(z1);
  }
}

GtkWidget *addButton(GtkWidget *box, char *icon, char *text, char *command, int sub) {
  GtkWidget *button;
  GtkWidget *pixmapwid;
  GdkPixmap *pixmap;
  GdkBitmap *mask;
  GtkStyle *style;
	GtkWidget *menu;
	GtkWidget *buttonbox;
	GtkWidget *label;
	int hasicon;
	int hastext;
	char *com;
	char iconfull[MAXSTRING+1];

	/* sub=0: Button
	   sub=1: New Menu
	   sub=2: Menu Item
		 sub=3: SubMen
	*/

	if((sub != 1) && (sub != 3)) {
		com=(char *)malloc(strlen(command)+1);
		if(com == (char *)NULL) {
			printf("Out of memory !\n");
			return(NULL);
		}
		strcpy(com,command);
	}

	hasicon=useicons;
	hastext=usetext;

	buttonbox=gtk_vbox_new(false,0);

	if(icon[0] == (char)NULL)
		hasicon=0;

	if(hasicon != 0) {
		snprintf(iconfull,(size_t)MAXSTRING,"%s/%s.xpm",ICOPRE,icon);

	 	style = gtk_widget_get_style(window);
 		pixmap=gdk_pixmap_create_from_xpm(window->window, &mask, &style->bg[GTK_STATE_NORMAL], iconfull);
		if(pixmap == NULL) {
			hasicon=0;
			hastext=1;
		}
	}
	else {
		hastext=1;
	}

	if(text[0] == (char)NULL)
		hastext=0;

	if(hasicon != 0)
	 	pixmapwid = gtk_pixmap_new( pixmap, mask );

	if((sub == 2) || (sub == 3)) {
		button=gtk_menu_item_new();
		gtk_menu_append(GTK_MENU(box),button);
	} else {
		button=gtk_button_new();
		gtk_box_pack_start(GTK_BOX(box),button,false,false,0);
	}

	gtk_container_add(GTK_CONTAINER(button),buttonbox);

	if(hasicon != 0) {
		gtk_box_pack_start(GTK_BOX(buttonbox),pixmapwid,false,false,0);
		gtk_widget_show( pixmapwid );
	}

	if(hastext != 0) {
		label=gtk_label_new(text);
	} else {
		if(hasicon == 0) {
			label=gtk_label_new(BUTTON);
			hastext = 1;
		}
	}
		
	if(hastext != 0) {	
		gtk_box_pack_start(GTK_BOX(buttonbox),label,false,false,0);
		gtk_widget_show(label);
	}

	if((text[0] != (char)NULL) && (hastext == 0))
 		gtk_tooltips_set_tip(GTK_TOOLTIPS(tooltips),button,text,text);
	if(sub == 0) {
 		gtk_signal_connect (GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC (execCom), com);
	}
	if(sub == 2) {
		gtk_signal_connect (GTK_OBJECT (button), "activate", GTK_SIGNAL_FUNC (execCom), com);
	}	
	if(sub == 1) {
		menu=gtk_menu_new();
		gtk_signal_connect (GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC (execSub), menu);
	}
	if(sub == 3) {
		menu=gtk_menu_new();
		gtk_menu_item_set_submenu(GTK_MENU_ITEM(button),menu);
	}
 	gtk_widget_show(button);
	gtk_widget_show(buttonbox);

	if(sub == 0)
		return(button);
	if(sub == 1)
		return(menu);
	if(sub == 2)
		return(button);
	if(sub == 3)
		return(menu);
	return(NULL);
}

void upperandclean(char *string, int noup) {
	char *z1;

	z1=string;
	
	while((*z1 == ' ') && (*z1 != (char)NULL))
		z1++;

	while(*z1 != (char)NULL) {
		if((*z1 == 0xa) || (*z1 == 0x9)) {
			z1++;
		} else {
			if(*z1 == '#') {
				*string++=(char)NULL;
			} else {
				if(noup == 0)
					*string++=toupper(*z1++);
				else
					*string++=*z1++;
			}
		}
	}
	*string=(char)NULL;
}

void parseCommands(GtkWidget *box, GtkWidget *secbox, FILE *dat, int men) {
	char line[MAXSTRING*3+4];
	char *z1;
	char *icon,*text,*command;
	GtkWidget *shellentry;
	
	z1=fgets(line,MAXSTRING*3+3,dat);
	while(z1 != (char *)NULL) {
		upperandclean(z1,1);
		if((*z1 != '#') && (*z1 != (char)NULL)) {

			if(*z1 == '[') {
				upperandclean(line,0);
				if(strstr(z1,"[END]") == z1) {
					return;
				}
				if(strstr(z1,"[SHELL]") == z1) {
					shellentry=gtk_entry_new();
					gtk_widget_set_usize(GTK_WIDGET(shellentry),TEXTHEIGHT,-1);
					if(buttonalign=='V') {
						gtk_box_pack_start(GTK_BOX(box),shellentry,false,false,0);
					} else {
						gtk_box_pack_start(GTK_BOX(secbox),shellentry,false,false,0);
					}
					gtk_signal_connect(GTK_OBJECT(shellentry), "activate", GTK_SIGNAL_FUNC(execCom),"[SHELL]");
					gtk_widget_show(shellentry);
				}
			}
			else {
				icon=z1;
				text=strchr(icon,':');
				if(text != (char *)NULL) {
					*text=(char)NULL;
					text++;
					command=strchr(text,':');
					if(command != (char *)NULL) {
						*command=(char)NULL;
						command++;
						z1=command;
						while((*z1 != (char)NULL)) {
							if(*z1 == 0xa)
								*z1=' ';
							z1++;
						}
						if(strstr(command,"[SUB]") == command) {
							if(men == 2)
								parseCommands(addButton(box,icon,text,command,3), secbox, dat, 2);		/* subsub */
							else
								parseCommands(addButton(box,icon,text,command,1), secbox, dat, 2); 		/* sub */
						}
						else {	
							addButton(box,icon,text,command,men);	/* normal item */
						}
					}
				}

			}
		}
		z1=fgets(line,MAXSTRING*3+3,dat);
	}

}

void getconfig(char *cfile, GtkWidget *box, GtkWidget *secbox) {
	char path[MAXSTRING+1];
	FILE *dat;
	char line[MAXSTRING*3+4];
	char oline[MAXSTRING*3+4];
	char *z1,*z2,*z3;
	int flg;

	if(cfile != NULL) {	/* Search for commandline[1] as conffile */
		dat=fopen(cfile,"r");
	}
	else {
		dat=(FILE *)NULL;
	}
	if(dat == (FILE *)NULL) {
		strncpy(path,"bb.conf",(size_t)MAXSTRING);	/* actdir bb.conf */
		dat=fopen(path,"r");
		if( dat == (FILE *)NULL) {
			z1=strrchr(calledPath,'/');
			if(z1 != (char *)NULL) {
				*z1=(char)NULL;
				strncpy(path,calledPath,(size_t)MAXSTRING);
				strncat(path,"/bb.conf",(size_t)MAXSTRING);
				*z1='/';
				dat=fopen(path,"r");	/* where bb is called / bb.conf */
			}
			if(dat == (FILE *)NULL) {
				snprintf(path,(size_t)MAXSTRING,"%s/.bbrc",getenv("HOME"));	/* $HOME/.bbrc */
				dat=fopen(path,"r");
				if(dat == (FILE *)NULL) {
					strncpy(path,"/etc/bb.conf",(size_t)MAXSTRING);	/* /etc/bb.conf */
					dat=fopen(path,"r");
					if(dat == (FILE *)NULL) {
						return;
					}
				}
			}
		}
	}

	/* Config-File found, Searching for options */
	if(box == (GtkWidget *)NULL) {
		flg=0;
		z1=fgets(line,(size_t)MAXSTRING*3+3,dat);
		while(z1 != (char *)NULL) {
			strcpy(oline,line);
			upperandclean(z1,0);	
			if(flg == 1) {
				if(*z1=='[') {
					z1=(char *)NULL;
				}
				else {
					/* ALIGN */
					z2=strstr(z1,"ALIGN");
					if(z1==z2) {
						z3=strchr(z1,'=');
						if(z3 != (char *)NULL) {
							z3++;
							while((*z3 == ' ') && (*z3 != (char)NULL))
								z3++;
							if(*z3 == 'V')
								buttonalign='V';
							else
								buttonalign='H';
						}
					}
					/* TIPDELAY */
					z2=strstr(z1,"TIPDELAY");
					if(z1==z2) {
						z3=strchr(z1,'=');
						if(z3 != (char *)NULL) {
							z3++;
							while((*z3 == ' ') && (*z3 != (char)NULL))
								z3++;
							tipdelay=atoi(z3);
						}
					}
					/* XPOS */
					z2=strstr(z1,"XPOS");
					if(z1==z2) {
						z3=strchr(z1,'=');
						if(z3 != (char *)NULL) {
							z3++;
							while((*z3 == ' ') && (*z3 != (char)NULL))
								z3++;
							posx=atoi(z3);
						}
					}
					/* YPOS */
					z2=strstr(z1,"YPOS");
					if(z1==z2) {
						z3=strchr(z1,'=');
						if(z3 != (char *)NULL) {
							z3++;
							while((*z3 == ' ') && (*z3 != (char)NULL))
								z3++;
							posy=atoi(z3);
						}
					}
					/* LOAD */
					z2=strstr(z1,"LOAD");
					if(z1==z2) {
						z3=strchr(z1,'=');
						if(z3 != (char *)NULL) {
							z3++;
							while((*z3 == ' ') && (*z3 != (char)NULL))
								z3++;
							load=atoi(z3);
						}
					}
					/* USEICONS */
					z2=strstr(z1,"USEICONS");
					if(z1==z2) {
						z3=strchr(z1,'=');
						if(z3 != (char *)NULL) {
							z3++;
							while((*z3 == ' ') && (*z3 != (char)NULL))
								z3++;
							useicons=atoi(z3);
							if(useicons != 0)
								useicons=1;
						}
					}
					/* FQDN */
					z2=strstr(z1,"FQDN");
					if(z1==z2) {
						z3=strchr(z1,'=');
						if(z3 != (char *)NULL) {
							z3++;
							while((*z3 == ' ') && (*z3 != (char)NULL))
								z3++;
							fqdn=atoi(z3);
							if(fqdn != 1)
								fqdn=0;
						}
					}
					/* DECORATIONS */
					z2=strstr(z1,"DECORATIONS");
					if(z1==z2) {
						z3=strchr(z1,'=');
						if(z3 != (char *)NULL) {
							z3++;
							while((*z3 == ' ') && (*z3 != (char)NULL))
								z3++;
							usedecs=atoi(z3);
							if(usedecs != 0)
								usedecs=1;
						}
					}
					/* USETEXT */
					z2=strstr(z1,"USETEXT");	
					if(z1==z2) {
						z3=strchr(z1,'=');
						if(z3 != (char *)NULL) {
							z3++;
							while((*z3 == ' ') && (*z3 != (char)NULL))
								z3++;
							usetext=atoi(z3);
							if(usetext != 0)
								usetext=1;
						}
					}
					/* NPHUP */
					z2=strstr(z1,"NOHUP");
					if(z1==z2) {
						z3=strchr(z1,'=');
						if(z3 != (char *)NULL) {
							z3++;
							while((*z3 == ' ') && (*z3 != (char)NULL))
								z3++;
							nohup=atoi(z3);
							if(nohup != 1)
								nohup=0;
						}
					}
					/* HOST */
					z2=strstr(z1,"HOST");
					if(z1==z2) {
						z1=oline;	
						z3=strchr(z1,'=');
						if(z3 != (char *)NULL) {
							z3++;
							while((*z3 == ' ') && (*z3 != (char)NULL))
								z3++;
							if(*z3=='<')
								upperandclean(z3,0);
							else
								upperandclean(z3,1);
							strncpy(HOSTNAME,z3,(size_t)MAXSTRING);
						}
					}
					/* USER */
					z2=strstr(z1,"USER");
					if(z1==z2) {
						z1=oline;
						z3=strchr(z1,'=');
						if(z3 != (char *)NULL) {
							z3++;
							while((*z3 == ' ') && (*z3 != (char)NULL))
								z3++;
							if(*z3=='<')
								upperandclean(z3,0);
							else
								upperandclean(z3,1);
							strncpy(USERNAME,z3,(size_t)MAXSTRING);
						}
					}
					/* ICONPREFIX */
					z2=strstr(z1,"ICONPREFIX");
					if(z1==z2) {
						z1=oline;
						z3=strchr(z1,'=');
						if(z3 != (char *)NULL) {
							z3++;
							while((*z3 == ' ') && (*z3 != (char)NULL))
								z3++;
							if(*z3=='<')
								upperandclean(z3,0);
							else
								upperandclean(z3,1);
							strncpy(ICOPRE,z3,(size_t)MAXSTRING);
						}
					}

				}
			}
			if(flg == 0) {
				z2=strstr(z1,"[CONFIG]");
				if(z2 != (char *)NULL) {
					flg=1;
				}
			}	
			if(z1 != (char *)NULL)
				z1=fgets(line,(size_t)MAXSTRING*3+3,dat);
		}	
	}
	else {
		flg=0;
		z1=fgets(line,(size_t)MAXSTRING*3+3,dat);
		while(z1 != (char *)NULL) {
			upperandclean(z1,0);

			z2=strstr(z1,"[COMMANDS]");		
			if(z2 != (char *)NULL) {
				parseCommands(box, secbox, dat, 0);
				z1=(char *)NULL;
			}
			else {
				z1=fgets(line,(size_t)MAXSTRING*3+3,dat);
			}
		}	
	}
	fclose(dat);
}

void getLoad() {
	int ret;
	double loadavg[3];


	ret=getloadavg(&loadavg[0], 3);

	if(ret > 0) {
		snprintf(SLOAD,(size_t)MAXSTRING,"%.3f",loadavg[0]);
		
		if(USERHOST[0] != (char)NULL) 
			snprintf(LOAD,(size_t)MAXSTRING,"%s: %.3f, %.3f, %.3f",USERHOST,loadavg[0],loadavg[1],loadavg[2]);
		else
			snprintf(LOAD,(size_t)MAXSTRING,"%.3f, %.3f, %.3f",loadavg[0],loadavg[1],loadavg[2]);
	}
}

int loadUpdate (GtkWidget * widget, gpointer data) {
		getLoad();
		if(buttonalign=='H') {
			gtk_statusbar_pop(GTK_STATUSBAR(status),stid);
			stid=gtk_statusbar_get_context_id(GTK_STATUSBAR(status),"Load and Host");
			if(load != 0)
				gtk_statusbar_push(GTK_STATUSBAR(status),stid,LOAD);
			else
				gtk_statusbar_push(GTK_STATUSBAR(status),stid,HOSTNAME);
		} else {
			gtk_label_set_text(GTK_LABEL(loadlabel),SLOAD);
		}
    gtk_tooltips_set_tip(GTK_TOOLTIPS(tooltips),window,LOAD,LOAD);
    gtk_window_set_title(GTK_WINDOW(window),LOAD);

		return(true);
}

int main(int argc, char *argv[]) {
	GtkWidget *box;
	GtkWidget *secbox;
	GtkWidget *hostlabel;
	GtkWidget *userlabel;
	char *z1;

	calledPath=argv[0];

	gtk_init (&argc, &argv);

	HOSTNAME[0] = (char)NULL;
	USERNAME[0] = (char)NULL;
	USERHOST[0] = (char)NULL;
	ICOPRE[0] = (char)NULL;
	LOAD[0]=(char)NULL;
	SLOAD[0]=(char)NULL;
	status=NULL;
	stid=0;

	getconfig(argv[1],NULL,NULL);

	if(nohup == 1) {
		signal (SIGHUP, signal_handler);
		signal (SIGQUIT, signal_handler);
		signal (SIGTERM, signal_handler);
		signal (SIGUSR1, signal_handler);
		signal (SIGABRT, signal_handler);
		signal (SIGINT, signal_handler);
	}

	if((strstr(HOSTNAME,"<AUTO>") == HOSTNAME) || (HOSTNAME[0] == (char)NULL)) {
		gethostname(HOSTNAME,(size_t)MAXSTRING);
		
		if(fqdn == 0) {
			z1=strchr(HOSTNAME,'.');
			if(z1 != (char *)NULL)
				*z1=(char)NULL;
		}

	}

	if((strstr(USERNAME,"<AUTO>") == USERNAME) || (USERNAME[0] == (char)NULL)) {
		if(getenv("USER") != (char *)NULL)
			strncpy(USERNAME,getenv("USER"),(size_t)MAXSTRING);
	}
	if((strstr(USERNAME,"<AUTO>") == USERNAME) || (strstr(USERNAME,"<AUTO>") == USERNAME))
		USERNAME[0]=(char)NULL;


	tooltips=gtk_tooltips_new();
	gtk_tooltips_enable(tooltips);
	gtk_tooltips_set_delay(GTK_TOOLTIPS(tooltips),tipdelay*1000); 
    
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

	if(strstr(USERNAME,"<NONE>") != USERNAME) {
		strncpy(USERHOST,USERNAME,(size_t)MAXSTRING);
	}
 
	if(strstr(HOSTNAME,"<NONE>") != HOSTNAME) {
		if(strstr(USERNAME,"<NONE>") != USERNAME)
			strncat(USERHOST,"@",(size_t)MAXSTRING);
		strncat(USERHOST,HOSTNAME,(size_t)MAXSTRING);
	}

	if(USERHOST[0] != (char)NULL)
		gtk_window_set_title(GTK_WINDOW(window),USERHOST);

	gtk_window_set_default_size(GTK_WINDOW(window),-1,-1);
	if((posx >= 0) && (posy >=0)) {
		gtk_widget_set_uposition(window,posx,posy);
	}
	gtk_window_set_policy(GTK_WINDOW(window),false,false,true);	

	gtk_signal_connect (GTK_OBJECT (window), "delete_event", GTK_SIGNAL_FUNC (gtk_main_quit), NULL);
	gtk_signal_connect (GTK_OBJECT (window), "destroy", GTK_SIGNAL_FUNC (gtk_main_quit), NULL);

	if(buttonalign == 'V') {
		box=gtk_vbox_new(false,0);
		secbox=gtk_hbox_new(false,0);
	} else {
		box=gtk_hbox_new(false,0);
		secbox=gtk_vbox_new(false,0);
	}

	gtk_box_pack_start(GTK_BOX(secbox),box,false,false,0);
	gtk_container_add(GTK_CONTAINER(window),secbox);

	if(buttonalign == 'V') {
		if(strstr(HOSTNAME,"<NONE>") != HOSTNAME) {
			hostlabel=gtk_label_new(HOSTNAME);
			gtk_box_pack_start(GTK_BOX(box),hostlabel,false,false,0);
			gtk_widget_show(hostlabel);
		}
		if(strstr(USERNAME,"<NONE>") != USERNAME) {
			userlabel=gtk_label_new(USERNAME);
			gtk_box_pack_start(GTK_BOX(box),userlabel,false,false,0);
			gtk_widget_show(userlabel);
		}
	}

	gtk_widget_show  (window);

  if(usedecs == 0)
    gdk_window_set_decorations(window->window,0);

	if(load != 0) {
		getLoad();
		if(buttonalign == 'V') {
			loadlabel=gtk_label_new(SLOAD);
			gtk_box_pack_start(GTK_BOX(box),loadlabel,false,false,0);
			gtk_widget_show(loadlabel);
		}
		gtk_tooltips_set_tip(GTK_TOOLTIPS(tooltips),window,LOAD,LOAD);
		gtk_window_set_title(GTK_WINDOW(window),LOAD);
		gtk_timeout_add(load*1000, (GtkFunction)loadUpdate,NULL );
	}

	getconfig(argv[1],box,secbox);

	if(buttonalign=='H') {
		if((load != 0) || (USERHOST[0] != (char)NULL)) {
			status=gtk_statusbar_new();
			gtk_box_pack_start(GTK_BOX(secbox),status,false,false,0);
			gtk_widget_show(status);

			stid=gtk_statusbar_get_context_id(GTK_STATUSBAR(status),"Load and Host");

			if(load != 0)
				gtk_statusbar_push(GTK_STATUSBAR(status),stid,LOAD);
			else
				gtk_statusbar_push(GTK_STATUSBAR(status),stid,USERHOST);
		}
	}

	gtk_widget_show(box);
	gtk_widget_show(secbox);
	gtk_widget_show  (window);
	gtk_main ();
    
	return(0);
}
